import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.ArrayList;

public class ServeClient extends Thread {
	double UB = 0;
	boolean Oktraj = false;
	Socket connection;
	boolean wait = true;

	public ServeClient(Socket connection) {
		this.connection = connection;
	}

	public void run() {
		try {
			OutputStream outStream;
			DataOutputStream outDataStream;
			InputStream inStream;
			DataInputStream inDataStream;
			String message;
			outStream = connection.getOutputStream();
			inStream = connection.getInputStream();

			inDataStream = new DataInputStream(inStream);
			outDataStream = new DataOutputStream(outStream);
			message = new String("+OK READY");
			// Send to client +OK message
			outDataStream.writeUTF(message);
			message = "";
			message = inDataStream.readUTF();
			// Wait the +OK massage from client
			while (!message.contentEquals("+OK READY")) {
				Thread.sleep(500);
			}
			// Send to client trajectory message message
			outDataStream.writeUTF(Server.trajectory);
			// Wait for the Upper Bound
			message = "";
			message = inDataStream.readUTF();
			String[] UBmessage = message.split(" ");
			UB = Double.parseDouble(UBmessage[2]);
			// lock and unlock of share variables
			Server.lock.lock();
			Server.countclientsthread++;
			Server.ClientList.put(this, UB);
			Server.logDisplay.append("("+connection.getInetAddress()+") UB=" + UB+"\n");
			Server.lock.unlock();
			// wait for the computation of the main processes
			while (wait) {
				this.interrupt();
			}
			// split the trajectory to call LCSS
			String[] straj = Server.trajectory.split(",");
			ArrayList<Double> servertraj = new ArrayList<Double>();
			for (int i = 0; i < straj.length; i++) {
				servertraj.add( Double.parseDouble(straj[i]));
			}
			message = "";
			if (Oktraj) {
				message = new String("+OK SEND TRAJ");
				// Send to client -err message for trajectory
				outDataStream.writeUTF(message);
			} else {
				message = new String("+OK Close connection");
				// Send to client -err message for trajectory
				System.out.println("Message ="+message+" and ip :"+this.connection.getInetAddress());
				outDataStream.writeUTF(message);
				return;
			}
			System.out.println("Message ="+message+" and ip :"+this.connection.getInetAddress());
			// read the trajectory
			message = "";
			message = inDataStream.readUTF();
			// split the trajectory to call LCSS
			straj = message.split(" ");
			ArrayList<Double> clienttraj = new ArrayList<Double>();
			for (int i = 2; i < straj.length; i++) {
				clienttraj.add( Double.parseDouble(straj[i]));
			}

			Server.lock.lock();
			ThreadUB temp = new ThreadUB();
			temp.thread.connection = this.connection;
			temp.UB = UBLCSS.LCSS(servertraj, clienttraj);
			Server.logDisplay.append("("+this.connection.getInetAddress()+")LCSS="+temp.UB+"\n");
			Server.UBLCSSthread.add(temp);
			Server.lock.unlock();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
